-- Magic wall & Wild growth timer
Contato ---  Discord Famous7464 -
-- Config
local magicWallIds = {2128, 2129, 23089, 23091, 23092, 23093, 23094, 23115}
local magicWallTime = 20000
local wildGrowthIds = {2130, 10182}
local wildGrowthTime = 45000

-- Script
local activeTimers = {}

onAddThing(function(tile, thing)
  if not thing:isItem() then
    return
  end

  local timer = 0
  local id = thing:getId()

  if table.contains(magicWallIds, id) then
    timer = magicWallTime
  elseif table.contains(wildGrowthIds, id) then
    timer = wildGrowthTime
  else
    return
  end
  
  local pos = tile:getPosition().x .. "," .. tile:getPosition().y .. "," .. tile:getPosition().z
  if not activeTimers[pos] or activeTimers[pos] < now then    
    activeTimers[pos] = now + timer
  end
  tile:setTimer(activeTimers[pos] - now)
end)

onRemoveThing(function(tile, thing)
  if not thing:isItem() then
    return
  end

  local id = thing:getId()
  if table.contains(magicWallIds, id) or table.contains(wildGrowthIds, id) then
    local pos = tile:getPosition().x .. "," .. tile:getPosition().y .. "," .. tile:getPosition().z
    activeTimers[pos] = nil
    tile:setTimer(0)
  end  
end)

-- Função auxiliar para verificar se um valor está na tabela
function table.contains(table, element)
  for _, value in ipairs(table) do
    if value == element then
      return true
    end
  end
  return false
end


UI.Separator()

local cIcon = addIcon("cI",{text="Cave\nBot",switchable=false,moveable=true}, function()
  if CaveBot.isOff() then 
    CaveBot.setOn()
  else 
    CaveBot.setOff()
  end
end)
cIcon:setSize({height=30,width=50})
cIcon.text:setFont('verdana-11px-rounded')

local tIcon = addIcon("tI",{text="Target\nBot",switchable=false,moveable=true}, function()
  if TargetBot.isOff() then 
    TargetBot.setOn()
  else 
    TargetBot.setOff()
  end
end)
tIcon:setSize({height=30,width=50})
tIcon.text:setFont('verdana-11px-rounded')

macro(50,function()
  if CaveBot.isOn() then
    cIcon.text:setColoredText({"CaveBot\n","white","ON","green"})
  else
    cIcon.text:setColoredText({"CaveBot\n","white","OFF","red"})
  end
  if TargetBot.isOn() then
    tIcon.text:setColoredText({"Target\n","white","ON","green"})
  else
    tIcon.text:setColoredText({"Target\n","white","OFF","red"})
  end
end)


UI.Separator()

Sdf_Pvp= macro(200, "Super SD Fire", function()
    if g_game.isAttacking() then
        usewith(14265, g_game.getAttackingCreature())
        delay(400)
    end
end)

marrom = addIcon("(SDFire)", {item=14265, text="SD Fire"},
function(icon, isOn)
Sdf_Pvp.setOn(isOn)
end)

Sdi_Pvp= macro(200, "Super SD Ice", function()
    if g_game.isAttacking() then
        usewith(14263, g_game.getAttackingCreature())
        delay(400)
    end
end)

marrom = addIcon("(SDIce)", {item=14263, text="SD Ice"},
function(icon, isOn)
Sdi_Pvp.setOn(isOn)
end)

Sden_Pvp= macro(200, "Super SD Energy", function()
    if g_game.isAttacking() then
        usewith(14261, g_game.getAttackingCreature())
        delay(400)
    end
end)

marrom = addIcon("(SDEnergy) Pvp", {item=14261, text="SD Energy"},
function(icon, isOn)
Sden_Pvp.setOn(isOn)
end)

Sder_Pvp= macro(200, "Super SD Earth", function()
    if g_game.isAttacking() then
        usewith(14262, g_game.getAttackingCreature())
        delay(400)
    end
end)

marrom = addIcon("(SDEarth) Pvp", {item=14262, text="SD Earth"},
function(icon, isOn)
Sder_Pvp.setOn(isOn)
end)

Sdh_Pvp= macro(200, "Super SD Holy", function()
    if g_game.isAttacking() then
        usewith(14264, g_game.getAttackingCreature())
        delay(400)
    end
end)

marrom = addIcon("(SDHoly) Pvp", {item=14264, text="SD Holy"},
function(icon, isOn)
Sdh_Pvp.setOn(isOn)
end)

Sdd_Pvp= macro(200, "Super SD Death", function()
    if g_game.isAttacking() then
        usewith(3150, g_game.getAttackingCreature())
        delay(400)
    end
end)

marrom = addIcon("(SDDeath) Pvp", {item=3150, text="SD Death"},
function(icon, isOn)
Sdd_Pvp.setOn(isOn)
end)